CREATE OR REPLACE TRIGGER tri_permit_change_emp
BEFORE
INSERT OR DELETE OR UPDATE
ON emp
DECLARE
   not_insert         EXCEPTION;
   not_delete         EXCEPTION;
   not_update_sal     EXCEPTION;
   not_working_time   EXCEPTION;
BEGIN
   IF (TO_CHAR(SYSDATE,'DY') = '')
   OR ((TO_CHAR(SYSDATE,'HH24') < '09') OR (TO_CHAR(SYSDATE,'HH24') >= '17'))
      THEN
         IF INSERTING
            THEN RAISE not_insert;
         ELSIF DELETING 
            THEN RAISE not_delete;
         ELSIF UPDATING('SAL')
            THEN RAISE not_update_sal;
         ELSE RAISE not_working_time;
         END IF;
   ELSE NULL;
   END IF;
EXCEPTION
     WHEN not_insert
     THEN raise_application_error(-20326,'cƎԓɓ͂ĂB');
     WHEN not_delete
     THEN raise_application_error(-20325,'cƎԓɍ폜ĂB');
     WHEN not_update_sal
     THEN raise_application_error(-20327,'cƎԓɋ^z̕ύXĂB');
     WHEN not_working_time
     THEN raise_application_error(-20328,'cƎԓEMP\ύXĂB');
END;
/