CREATE OR REPLACE PROCEDURE pro_pl_bulk(sal_val NUMBER)
IS
   TYPE     empcurtyp IS REF CURSOR;
   TYPE     numlist IS TABLE OF NUMBER
               INDEX BY PLS_INTEGER;
   TYPE     namelist IS TABLE OF VARCHAR2(15)
               INDEX BY PLS_INTEGER;
   emp_cv   empcurtyp;
   empnos   numlist;
   enames   namelist;
   sals     numlist;
BEGIN
   OPEN emp_cv FOR 'SELECT empno,ename FROM emp
                    WHERE sal > '|| sal_val;
      FETCH emp_cv BULK COLLECT INTO empnos,enames;
   CLOSE emp_cv;
      FORALL i IN 1..empnos.count
         EXECUTE IMMEDIATE
            'DELETE FROM emp WHERE empno = :1 RETURNING sal INTO :2'
             USING empnos(i) RETURNING BULK COLLECT INTO sals;
   FOR i IN 1..empnos.COUNT LOOP
      DBMS_OUTPUT.PUT_LINE(empnos(i)||' '||enames(i)||' '||sals(i));
   END LOOP;
END;
/